﻿/*
 * Copyright (c) 2016 Samsung Electronics Co., Ltd
 *
 * Licensed under the Flora License, Version 1.1 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://floralicense.org/license/
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace SystemInfo
{
    /// <summary>

    /// SystemInfo interface declare .

    /// </summary>

    /// <remarks>

    /// Longer comments can be associated with a type or member through

    /// the remarks tag.

    /// </remarks>
    public interface ISystemInfo
    {
        /// <summary>

        /// obtain value from a Key param </summary>

        /// <param name="key"> a string value pair for another value.</param>

        /// <seealso cref="System.String">

        /// You can use the cref attribute on any tag to reference a type or member

        /// and the compiler will check that the reference exists. </seealso>
        bool IsValidKey(string key);
        /// <summary>

        /// Description for SomeMethod.</summary>

        /// <param name="s"> Parameter description for s goes here.</param>

        /// <seealso cref="System.String">

        /// You can use the cref attribute on any tag to reference a type or member

        /// and the compiler will check that the reference exists. </seealso>
        bool TryGetValueToBool(string key);
        /// <summary>

        /// Description for SomeMethod.</summary>

        /// <param name="s"> Parameter description for s goes here.</param>

        /// <seealso cref="System.String">

        /// You can use the cref attribute on any tag to reference a type or member

        /// and the compiler will check that the reference exists. </seealso>
        int TryGetValueToInt(string key);
        /// <summary>

        /// Description for SomeMethod.</summary>

        /// <param name="s"> Parameter description for s goes here.</param>

        /// <seealso cref="System.String">

        /// You can use the cref attribute on any tag to reference a type or member

        /// and the compiler will check that the reference exists. </seealso>
        double TryGetValueToDouble(string key);
        /// <summary>

        /// Description for SomeMethod.</summary>

        /// <param name="s"> Parameter description for s goes here.</param>

        /// <seealso cref="System.String">

        /// You can use the cref attribute on any tag to reference a type or member

        /// and the compiler will check that the reference exists. </seealso>
        string TryGetValueToString(string key);
        /// <summary>

        /// Description for SomeMethod.</summary>

        /// <param name="s"> Parameter description for s goes here.</param>

        /// <seealso cref="System.String">

        /// You can use the cref attribute on any tag to reference a type or member

        /// and the compiler will check that the reference exists. </seealso>
        DateTime TryGetValueToDateTime(string key);
        /// <summary>

        /// Description for SomeMethod.</summary>

        /// <param name="s"> Parameter description for s goes here.</param>

        /// <seealso cref="System.String">

        /// You can use the cref attribute on any tag to reference a type or member

        /// and the compiler will check that the reference exists. </seealso>
        bool IsBool(string key);
        /// <summary>

        /// Description for SomeMethod.</summary>

        /// <param name="s"> Parameter description for s goes here.</param>

        /// <seealso cref="System.String">

        /// You can use the cref attribute on any tag to reference a type or member

        /// and the compiler will check that the reference exists. </seealso>
        bool IsDataTime(string key);
        /// <summary>

        /// Description for SomeMethod.</summary>

        /// <param name="s"> Parameter description for s goes here.</param>

        /// <seealso cref="System.String">

        /// You can use the cref attribute on any tag to reference a type or member

        /// and the compiler will check that the reference exists. </seealso>
        bool IsInt(string key);
        /// <summary>

        /// Description for SomeMethod.</summary>

        /// <param name="s"> Parameter description for s goes here.</param>

        /// <seealso cref="System.String">

        /// You can use the cref attribute on any tag to reference a type or member

        /// and the compiler will check that the reference exists. </seealso>
        bool IsDouble(string key);
        /// <summary>

        /// Description for SomeMethod.</summary>

        /// <param name="s"> Parameter description for s goes here.</param>

        /// <seealso cref="System.String">

        /// You can use the cref attribute on any tag to reference a type or member

        /// and the compiler will check that the reference exists. </seealso>
        bool IsString(string key);
    }
}
